diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
index 66ac1f5bb..1eda5e312 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
@@ -2,11 +2,12 @@ package net.minecraft.client.gui.guidebook.mobs;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.entity.EntityRenderer;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 
 import java.util.*;
@@ -29,148 +30,148 @@ public abstract class MobInfoRegistry {
     }
 
     static {
-        register(EntityPig.class,
+        register(PigMob.class,
             "guidebook.section.mob.pig.name",
             "guidebook.section.mob.pig.desc",
             10,
             10,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.foodPorkchopRaw), 1.0F, 1, 2)
+                new MobDrop(new ItemStack(Items.FOOD_PORKCHOP_RAW), 1.0F, 1, 2)
             }
         );
-        register(EntitySheep.class,
+        register(SheepMob.class,
             "guidebook.section.mob.sheep.name",
             "guidebook.section.mob.sheep.desc",
             10,
             10,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Block.wool), 1.0F, 1, 1)
+                new MobDrop(new ItemStack(Blocks.WOOL), 1.0F, 1, 1)
             }
         );
-        register(EntityCow.class,
+        register(CowMob.class,
             "guidebook.section.mob.cow.name",
             "guidebook.section.mob.cow.desc",
             10,
             10,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.leather), 1.0F, 1, 5)
+                new MobDrop(new ItemStack(Items.LEATHER), 1.0F, 1, 5)
             }
         );
-        register(EntityChicken.class,
+        register(ChickenMob.class,
             "guidebook.section.mob.chicken.name",
             "guidebook.section.mob.chicken.desc",
             4,
             10,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.featherChicken), 0.66f, 1, 2)
+                new MobDrop(new ItemStack(Items.FEATHER_CHICKEN), 0.66f, 1, 2)
             }
         );
-        register(EntitySquid.class,
+        register(SquidMob.class,
             "guidebook.section.mob.squid.name",
             "guidebook.section.mob.squid.desc",
             10,
             10,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.dye, 1, 0), 1.0F, 1, 3)
+                new MobDrop(new ItemStack(Items.DYE, 1, 0), 1.0F, 1, 3)
             }
         );
-        register(EntityWolf.class,
+        register(WolfMob.class,
             "guidebook.section.mob.wolf.name",
             "guidebook.section.mob.wolf.desc",
             8,
             500,
             null
         );
-        register(EntityFireflyCluster.class,
+        register(FireflyClusterMob.class,
             "guidebook.section.mob.firefly_cluster.name",
             "guidebook.section.mob.firefly_cluster.desc",
             -1,
             -1,
             null
         );
-        register(EntityZombie.class,
+        register(ZombieMob.class,
             "guidebook.section.mob.zombie.name",
             "guidebook.section.mob.zombie.desc",
             20,
             300,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.cloth), 0.66f, 1, 2)
+                new MobDrop(new ItemStack(Items.CLOTH), 0.66f, 1, 2)
             }
         );
-        register(EntityArmoredZombie.class,
+        register(ZombieArmoredMob.class,
             "guidebook.section.mob.armored_zombie.name",
             "guidebook.section.mob.armored_zombie.desc",
             40,
             1000,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.cloth), 1.0F, 1, 2),
-                new MobDrop(new ItemStack(Item.chainlink), 0.8f, 1, 4)
+                new MobDrop(new ItemStack(Items.CLOTH), 1.0F, 1, 2),
+                new MobDrop(new ItemStack(Items.CHAINLINK), 0.8f, 1, 4)
             }
         );
-        register(EntitySnowman.class,
+        register(SnowmanMob.class,
             "guidebook.section.mob.snowman.name",
             "guidebook.section.mob.snowman.desc",
             20,
             300,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.ammoSnowball), 0.66f, 1, 2)
+                new MobDrop(new ItemStack(Items.AMMO_SNOWBALL), 0.66f, 1, 2)
             }
         );
-        register(EntityCreeper.class,
+        register(CreeperMob.class,
             "guidebook.section.mob.creeper.name",
             "guidebook.section.mob.creeper.desc",
             20,
             800,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.sulphur), 0.66f, 1, 2)
+                new MobDrop(new ItemStack(Items.SULPHUR), 0.66f, 1, 2)
             }
         );
-        register(EntitySkeleton.class,
+        register(SkeletonMob.class,
             "guidebook.section.mob.skeleton.name",
             "guidebook.section.mob.skeleton.desc",
             20,
             500,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.bone), 0.66f, 1, 2),
-                new MobDrop(new ItemStack(Item.ammoArrow), 0.66f, 1, 2)
+                new MobDrop(new ItemStack(Items.BONE), 0.66f, 1, 2),
+                new MobDrop(new ItemStack(Items.AMMO_ARROW), 0.66f, 1, 2)
             }
         );
-        register(EntitySpider.class,
+        register(SpiderMob.class,
             "guidebook.section.mob.spider.name",
             "guidebook.section.mob.spider.desc",
             20,
             200,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.string), 0.66f, 1, 2)
+                new MobDrop(new ItemStack(Items.STRING), 0.66f, 1, 2)
             }
         );
-        register(EntitySlime.class,
+        register(SlimeMob.class,
             "guidebook.section.mob.slime.name",
             "guidebook.section.mob.slime.desc",
             -1,
             100,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.slimeball), 0.66f, 1, 2)
+                new MobDrop(new ItemStack(Items.SLIMEBALL), 0.66f, 1, 2)
             }
         );
-        register(EntityGhast.class,
+        register(GhastMob.class,
             "guidebook.section.mob.ghast.name",
             "guidebook.section.mob.ghast.desc",
             20,
             1000,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.sulphur), 0.66f, 1, 2)
+                new MobDrop(new ItemStack(Items.SULPHUR), 0.66f, 1, 2)
             }
         );
-        register(EntityPigZombie.class,
+        register(ZombiePigMob.class,
             "guidebook.section.mob.zombie_pigman.name",
             "guidebook.section.mob.zombie_pigman.desc",
             20,
             500,
             new MobDrop[] {
-                new MobDrop(new ItemStack(Item.foodPorkchopRaw), 0.45f * 0.66f, 1, 2),
-                new MobDrop(new ItemStack(Item.oreRawGold), 0.04f * 0.66f, 1, 2),
-                new MobDrop(new ItemStack(Item.toolSwordGold), 0.01f * 0.66f, 1, 1)
+                new MobDrop(new ItemStack(Items.FOOD_PORKCHOP_RAW), 0.45f * 0.66f, 1, 2),
+                new MobDrop(new ItemStack(Items.ORE_RAW_GOLD), 0.04f * 0.66f, 1, 2),
+                new MobDrop(new ItemStack(Items.TOOL_SWORD_GOLD), 0.01f * 0.66f, 1, 1)
             }
         );
     }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
index 4de8c09ff..fd44d2cd8 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
@@ -7,17 +7,17 @@ import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.render.*;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.Global;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotGuidebook;
+import net.minecraft.core.player.inventory.slot.GuidebookSlot;
 import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
@@ -29,11 +29,11 @@ public class MobPage
     extends GuidebookPage {
     private final Class<? extends Entity> mobClass;
     private final MobInfoRegistry.MobInfo mobInfo;
-    private final EntityLiving example;
+    private final Mob example;
     private String[] descLines;
     private String[] unknownDescLines;
-    private List<SlotGuidebook> slots;
-    private Map<MobInfoRegistry.MobDrop, SlotGuidebook> dropSlotMap;
+    private List<GuidebookSlot> slots;
+    private Map<MobInfoRegistry.MobDrop, GuidebookSlot> dropSlotMap;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
     private static final GuiRenderItem guiRenderItem = new GuiRenderItem(mc);
     private static final GuiTooltip guiTooltip = new GuiTooltip(mc);
@@ -46,9 +46,9 @@ public class MobPage
 
         this.mobClass = mobClass;
         this.mobInfo = mobInfo;
-        EntityLiving example = null;
+        Mob example = null;
         try {
-            example = (EntityLiving) mobClass.getConstructor(World.class).newInstance((Object)null);
+            example = (Mob) mobClass.getConstructor(World.class).newInstance((Object)null);
         } catch (Exception e) {
             e.printStackTrace();
         }
@@ -60,7 +60,7 @@ public class MobPage
             dropSlotMap = new HashMap<>();
             for (int i = 0; i < mobInfo.getDrops().length; i++) {
                 MobInfoRegistry.MobDrop drop = mobInfo.getDrops()[i];
-                SlotGuidebook slot = new SlotGuidebook(i, 0, 0, new RecipeSymbol(drop.getStack()), false, null);
+                GuidebookSlot slot = new GuidebookSlot(i, 0, 0, new RecipeSymbol(drop.getStack()), false, null);
                 slots.add(slot);
                 dropSlotMap.put(drop, slot);
             }
@@ -99,7 +99,7 @@ public class MobPage
     @Override
     protected void renderBackground(RenderEngine re, int x, int y) {
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/guidebook/mob.png"));
+        re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/mob.png"));
         drawTexturedModalRect(x, y, 0, 0, 158, 220);
     }
 
@@ -139,10 +139,9 @@ public class MobPage
                         drawStringNoShadow(fr, i18n.translateKey("guidebook.section.mob.health"), x + 66, yOffset, 0x505050);
                         yOffset += 6;
                         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-                        GL11.glBindTexture(GL11.GL_TEXTURE_2D, re.getTexture("/assets/minecraft/textures/gui/icons.png"));
                         yOffset += 4;
-                        drawTexturedModalRect(x + 66, yOffset, 16, 0, 9, 9);
-                        drawTexturedModalRect(x + 66, yOffset, 52, 0, 9, 9);
+                        drawGuiIcon(x + 66, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
+                        drawGuiIcon(x + 66, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/full"));
                         drawStringNoShadow(fr, "x "+mobInfo.getHealth()/2, x + 66 + 12, yOffset, 0x505050);
 
                     } else {
@@ -150,17 +149,16 @@ public class MobPage
                         drawStringNoShadow(fr, i18n.translateKey("guidebook.section.mob.health"), x + 66, yOffset, 0x505050);
                         yOffset += 6;
                         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-                        GL11.glBindTexture(GL11.GL_TEXTURE_2D, re.getTexture("/assets/minecraft/textures/gui/icons.png"));
                         for (int i = 0; i < mobInfo.getHealth() / 2; i++) {
                             if (i % 10 == 0) {
                                 yOffset += 4;
                             }
-                            drawTexturedModalRect(x + 66 + (i % 10) * 8, yOffset, 16, 0, 9, 9);
-                            drawTexturedModalRect(x + 66 + (i % 10) * 8, yOffset, 52, 0, 9, 9);
+                            drawGuiIcon(x + 66 + (i % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
+                            drawGuiIcon(x + 66 + (i % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/full"));
                         }
                         if (mobInfo.getHealth() % 2 == 1) {
-                            drawTexturedModalRect(x + 66 + ((mobInfo.getHealth() / 2) % 10) * 8, yOffset, 16, 0, 9, 9);
-                            drawTexturedModalRect(x + 66 + ((mobInfo.getHealth() / 2) % 10) * 8, yOffset, 61, 0, 9, 9);
+                            drawGuiIcon(x + 66 + ((mobInfo.getHealth() / 2) % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
+                            drawGuiIcon(x + 66 + ((mobInfo.getHealth() / 2) % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/half"));
                         }
                     }
                 }
@@ -186,15 +184,15 @@ public class MobPage
                     drawStringNoShadow(fr, i18n.translateKey("guidebook.section.mob.drops"), x + 8, yOffset, 0x000000);
                     yOffset += 12;
                     for (int i = 0; i < mobInfo.getDrops().length; i++) {
-                        SlotGuidebook slot = slots.get(i);
-                        slot.xDisplayPosition = 7 + (i % 7) * 21;
-                        slot.yDisplayPosition = (yOffset - y) + (i / 7) * 20;
+                        GuidebookSlot slot = slots.get(i);
+                        slot.x = 7 + (i % 7) * 21;
+                        slot.y = (yOffset - y) + (i / 7) * 20;
                         MobInfoRegistry.MobDrop drop = mobInfo.getDrops()[i];
                         boolean mouseOver = getIsMouseOverSlot(slot, x, y, mouseX, mouseY);
-                        drawSlot(re, x + 7 + (i % 7) * 21, yOffset + (i / 7) * 20, 0xFFFFFFFF);
+                        drawSlot(x + 7 + (i % 7) * 21, yOffset + (i / 7) * 20, 0xFFFFFFFF);
                         GL11.glPushMatrix();
                         GL11.glTranslatef(0, 0, 50f);
-                        guiRenderItem.render(slot.getStack(), x + 8 + (i % 7) * 21, yOffset + 1 + (i / 7) * 20, mouseOver, slot);
+                        guiRenderItem.render(slot.getItem(), x + 8 + (i % 7) * 21, yOffset + 1 + (i / 7) * 20, mouseOver, slot);
                         GL11.glPopMatrix();
                         if (slot.getIsDiscovered(mc.thePlayer)) {
                             String amountString = drop.getMinAmount() == drop.getMaxAmount() ? String.valueOf(drop.getMinAmount()) : drop.getMinAmount() + "-" + drop.getMaxAmount();
@@ -222,15 +220,15 @@ public class MobPage
         if (discovered) {
             if (mouseX > x + 9 && mouseX < x + 9 + 52 && mouseY > y + 9 && mouseY < y + 9 + 70) {
                 // TODO possibly replace with a function to be called inside the Entity itself?
-                int highestSkinVariant = Global.accessor.getSkinVariantList().getNumSkinsForEntity(mobClass) - 1;
-                if (highestSkinVariant > 0) {
-                    int newSkinVariant = (example.getSkinVariant() + 1) % (highestSkinVariant + 1);
-                    example.setSkinVariant(newSkinVariant);
-                }
-                if (example instanceof EntityFireflyCluster){
-                    EntityFireflyCluster.FireflyColor color = EntityFireflyCluster.FireflyColor.fireFlyColors.get(
-                            ((EntityFireflyCluster) example).getColor().getId() + 1 % EntityFireflyCluster.FireflyColor.fireFlyColors.size());
-                    ((EntityFireflyCluster) example).setColor(color == null ? EntityFireflyCluster.FireflyColor.GREEN : color);
+//                int highestSkinVariant = Global.accessor.getSkinVariantList().getNumSkinsForEntity(mobClass) - 1;
+//                if (highestSkinVariant > 0) {
+//                    int newSkinVariant = (example.getSkinVariant() + 1) % (highestSkinVariant + 1);
+//                    example.setSkinVariant(newSkinVariant);
+//                }
+                if (example instanceof FireflyClusterMob){
+                    FireflyClusterMob.FireflyColor color = FireflyClusterMob.FireflyColor.fireFlyColors.get(
+                            ((FireflyClusterMob) example).getColor().getId() + 1 % FireflyClusterMob.FireflyColor.fireFlyColors.size());
+                    ((FireflyClusterMob) example).setColor(color == null ? FireflyClusterMob.FireflyColor.GREEN : color);
                 }
                 String livingSound = example.getLivingSound();
                 if (livingSound != null) {
@@ -269,7 +267,7 @@ public class MobPage
         Lighting.enableLight();
         GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
         GL11.glRotatef(-(float)Math.atan(f6 / 40F) * 20F, 1.0F, 0.0F, 0.0F);
-        example.renderYawOffset = (float)Math.atan(f5 / 40F) * 20F;
+        example.yBodyRot = (float)Math.atan(f5 / 40F) * 20F;
         example.yRot = (float)Math.atan(f5 / 40F) * 40F;
         example.xRot = -(float)Math.atan(f6 / 40F) * 20F;
         example.entityBrightness = 1.0F;
@@ -278,7 +276,7 @@ public class MobPage
         EntityRenderDispatcher.instance.renderEntityPreviewWithPosYaw(Tessellator.instance, example, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
         GL11.glPopMatrix();
         Lighting.disable();
-        GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GL11.glDisable(GL11.GL_DEPTH_TEST);
 
         Scissor.disable();
@@ -288,14 +286,14 @@ public class MobPage
     protected void renderOverlay(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, fr, x, y, mouseX, mouseY, partialTicks);
         if (slots == null) return;
-        SlotGuidebook mouseOverSlot = null;
-        for (SlotGuidebook slot : slots) {
+        GuidebookSlot mouseOverSlot = null;
+        for (GuidebookSlot slot : slots) {
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            if (mouseOverSlot != null && mouseOverSlot.hasStack())
+            if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = guiTooltip.getTooltipText(mouseOverSlot.getStack(), showDescription, mouseOverSlot);
+                String str = guiTooltip.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     guiTooltip.render(str, mouseX, mouseY, 8, -8);
@@ -307,7 +305,7 @@ public class MobPage
 
     public boolean getIsMouseOverSlot(final Slot slot, int x, int y, int mouseX, int mouseY)
     {
-        return mouseX >= x+slot.xDisplayPosition - 1 && mouseX < x+slot.xDisplayPosition + 16 + 1 && mouseY >= y+slot.yDisplayPosition - 1 && mouseY < y+slot.yDisplayPosition + 16 + 1;
+        return mouseX >= x+slot.x - 1 && mouseX < x+slot.x + 16 + 1 && mouseY >= y+slot.y - 1 && mouseY < y+slot.y + 16 + 1;
     }
 
 }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobSection.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobSection.java
index c0f43b63f..88fed6e73 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobSection.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobSection.java
@@ -9,6 +9,7 @@ import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.gamemode.Gamemode;
@@ -24,7 +25,7 @@ public class MobSection
     private final List<GuidebookSection.Index> indices = new ArrayList<>();
     private Pair<String,List<GuidebookPage>> filteredPages = null;
     public MobSection() {
-        super("guidebook.section.mob", new ItemStack(Item.bone), 0x66962B, 0xC29B1C);
+        super("guidebook.section.mob", new ItemStack(Items.BONE), 0x66962B, 0xC29B1C);
 
         for (Class<? extends Entity> e : MobInfoRegistry.getMobClassList()) {
             MobInfoRegistry.MobInfo mobInfo = MobInfoRegistry.getMobInfo(e);
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/search/SearchSection.java b/src/main/java/net/minecraft/client/gui/guidebook/search/SearchSection.java
index 79acc32b6..78ec495d9 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/search/SearchSection.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/search/SearchSection.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.guidebook.search;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
 
 import java.util.ArrayList;
@@ -13,7 +14,7 @@ public class SearchSection
     private final List<GuidebookPage> pages = new ArrayList<>();
 
     public SearchSection() {
-        super("guidebook.section.search", new ItemStack(Block.glass), 0x808080,0xFFFFFF);
+        super("guidebook.section.search", new ItemStack(Blocks.GLASS), 0x808080,0xFFFFFF);
         pages.add(new SearchPage(this));
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
index e2fd8bb4c..4311a3a2b 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
@@ -12,13 +12,13 @@ import net.minecraft.client.gui.guidebook.RecipePage;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryBlastFurnace;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotGuidebook;
+import net.minecraft.core.player.inventory.slot.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -30,12 +30,12 @@ import java.util.Map;
 public class BlastSmeltingPage
     extends RecipePage<RecipeEntryBlastFurnace> {
     public static final int RECIPES_PER_PAGE = 6;
-    public List<SlotGuidebook> slots;
-    public Map<RecipeEntryBlastFurnace,List<SlotGuidebook>> map;
+    public List<GuidebookSlot> slots;
+    public Map<RecipeEntryBlastFurnace,List<GuidebookSlot>> map;
     private final GuiTooltip guiTooltip;
     private final GuiRenderItem guiRenderItem;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
-    private static EntityPlayer player;
+    private static Player player;
     private static long ticks = 0;
     public BlastSmeltingPage(GuidebookSection section, ArrayList<RecipeEntryBlastFurnace> recipes) {
         super(section);
@@ -43,14 +43,14 @@ public class BlastSmeltingPage
         this.slots = new ArrayList<>();
         this.map = new HashMap<>();
         player = mc.thePlayer;
-        player.addStat(AchievementList.OPEN_GUIDEBOOK,1);
+        player.addStat(Achievements.OPEN_GUIDEBOOK,1);
         guiTooltip = new GuiTooltip(mc);
         guiRenderItem = new GuiRenderItem(mc);
 
         for (RecipeEntryBlastFurnace recipe : recipes) {
-            List<SlotGuidebook> recipeSlots = new ArrayList<>();
-            recipeSlots.add(new SlotGuidebook(0, (width/2)-32, 32*(map.size()+1)-16, recipe.getInput(), false,recipe));
-            recipeSlots.add(new SlotGuidebook(1, (width/2)+24, 32*(map.size()+1)-16, new RecipeSymbol(recipe.getOutput()), false,recipe));
+            List<GuidebookSlot> recipeSlots = new ArrayList<>();
+            recipeSlots.add(new GuidebookSlot(0, (width/2)-32, 32*(map.size()+1)-16, recipe.getInput(), false,recipe));
+            recipeSlots.add(new GuidebookSlot(1, (width/2)+24, 32*(map.size()+1)-16, new RecipeSymbol(recipe.getOutput()), false,recipe));
             map.put(recipe,recipeSlots);
             slots.addAll(recipeSlots);
         }
@@ -61,37 +61,37 @@ public class BlastSmeltingPage
         if(recipes.isEmpty()){
             drawStringCenteredNoShadow(fr,"No recipes found :(" ,x+width/2,y+height/2,0xFF808080);
         }
-        SlotGuidebook mouseOverSlot = null;
+        GuidebookSlot mouseOverSlot = null;
         ticks++;
-        for (SlotGuidebook slot : slots) {
+        for (GuidebookSlot slot : slots) {
             if(ticks > 150) {
                 slot.showRandomItem();
                 if(slots.get(slots.size()-1) == slot){
                     ticks = 0;
                 }
             }
-            drawSlot(re,x+slot.xDisplayPosition-1,y+slot.yDisplayPosition-1,0xFFFFFFFF);
+            drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            guiRenderItem.render(slot.getStack(),x+slot.xDisplayPosition,y+slot.yDisplayPosition,mouseOverSlot == slot,slot);
+            guiRenderItem.render(slot.getItem(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
         }
     }
 
     public boolean getIsMouseOverSlot(final Slot slot, int x, int y, int mouseX, int mouseY)
     {
-        return mouseX >= x+slot.xDisplayPosition - 1 && mouseX < x+slot.xDisplayPosition + 16 + 1 && mouseY >= y+slot.yDisplayPosition - 1 && mouseY < y+slot.yDisplayPosition + 16 + 1;
+        return mouseX >= x+slot.x - 1 && mouseX < x+slot.x + 16 + 1 && mouseY >= y+slot.y - 1 && mouseY < y+slot.y + 16 + 1;
     }
 
     @Override
     public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         super.keyTyped(c, key, x, y, mouseX, mouseY);
         if(mc.gameSettings.keyShowRecipe.isKeyboardKey(key)){
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
+            GuidebookSlot hoveringSlot= null;
+            for (GuidebookSlot slot : slots) {
                 if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
             }
             if(hoveringSlot != null){
-                if(hoveringSlot.hasStack()){
-                    String query = "r:"+hoveringSlot.getStack().getDisplayName()+"!";
+                if(hoveringSlot.hasItem()){
+                    String query = "r:"+hoveringSlot.getItem().getDisplayName()+"!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
                     GuiGuidebook.getPageManager().updatePages();
@@ -99,13 +99,13 @@ public class BlastSmeltingPage
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
+            GuidebookSlot hoveringSlot= null;
+            for (GuidebookSlot slot : slots) {
                 if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
             }
             if(hoveringSlot != null) {
-                if (hoveringSlot.hasStack()) {
-                    String query = "u:" + hoveringSlot.getStack().getDisplayName() + "!";
+                if (hoveringSlot.hasItem()) {
+                    String query = "u:" + hoveringSlot.getItem().getDisplayName() + "!";
                     PageManager.searchQuery = SearchQuery.resolve(query);
                     SearchPage.searchField.setText(query);
                     GuiGuidebook.getPageManager().updatePages();
@@ -124,25 +124,25 @@ public class BlastSmeltingPage
     @Override
     protected void renderBackground(RenderEngine re, int x, int y) {
         super.renderBackground(re, x, y);
-        re.bindTexture(re.getTexture("/assets/minecraft/textures/gui/guidebook/guidebook.png"));
+        re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
         for (int i = 1; i <= recipes.size(); i++) {
             RecipeEntryBlastFurnace recipe = recipes.get(i-1);
-            List<SlotGuidebook> list = map.get(recipe);
-            drawTexturedModalRect(x + list.get(list.size()-1).xDisplayPosition - 32, y +  list.get(list.size()-1).yDisplayPosition, 234, 0, 22, 15);
+            List<GuidebookSlot> list = map.get(recipe);
+            drawTexturedModalRect(x + list.get(list.size()-1).x - 32, y +  list.get(list.size()-1).y, 234, 0, 22, 15);
         }
     }
 
     @Override
     protected void renderOverlay(RenderEngine re, FontRenderer fr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, fr, x, y, mouseX, mouseY, partialTicks);
-        SlotGuidebook mouseOverSlot = null;
-        for (SlotGuidebook slot : slots) {
+        GuidebookSlot mouseOverSlot = null;
+        for (GuidebookSlot slot : slots) {
             if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            if (mouseOverSlot != null && mouseOverSlot.hasStack())
+            if (mouseOverSlot != null && mouseOverSlot.hasItem())
             {
                 boolean showDescription = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) || mc.gameSettings.alwaysShowDescriptions.value;
-                String str = guiTooltip.getTooltipText(mouseOverSlot.getStack(), showDescription, mouseOverSlot);
+                String str = guiTooltip.getTooltipText(mouseOverSlot.getItem(), showDescription, mouseOverSlot);
                 if(!str.isEmpty())
                 {
                     guiTooltip.render(str, mouseX, mouseY, 8, -8);
